=== xtp/share/CMakeLists.txt ===
add_subdirectory(xtp/basis_sets)
add_subdirectory(xtp/xml)
add_subdirectory(xtp/ecps)
add_subdirectory(benchmark)
add_subdirectory(doc)
