=== debian/changelog ===
votca (2022.1-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Breen <nbreen@debian.org>  Mon, 02 Jan 2023 12:10:30 -0800

votca (2022-4) unstable; urgency=medium

  * d/watch: Update to work around github changes.
  * Formatting updates for lintian overrides.
  * New patch tutorial-spce-py3.patch: Cherry-pick upstream port of the
    last remaining Python 2 tutorial script to Python 3.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 15 Oct 2022 09:38:50 -0700
